/* Zaurus framebuffer VNC server

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version
   2 of the License, or (at your option) any later version.

   (c) Pierre-Philippe Coupard, 27/01/2002
*/
#include "keysym.h"
#include "rfb.h"
#include "keysym2scancode.h"



/* Scancode sequences */
#define suchar static unsigned char
#define DOWN 1
#define UP 0
#define END 0xff

#ifdef IPAQ
#define SHIFT 0x2a
suchar XK_BackSpace_seq[]={0x0e,DOWN,0x0e,UP,END};
suchar XK_Tab_seq[]={0x0f,DOWN,0x0f,UP,END};
suchar XK_Return_seq[]={0x1c,DOWN,0x1c,UP,END};
suchar XK_Escape_seq[]={0x01,DOWN,0x01,UP,END};
suchar XK_space_seq[]={0x39,DOWN,0x39,UP,END};
suchar XK_exclam_seq[]={SHIFT,DOWN,0x02,DOWN,0x02,UP,SHIFT,UP,END};
suchar XK_quotedbl_seq[]={SHIFT,DOWN,0x28,DOWN,0x28,UP,SHIFT,UP,END};
suchar XK_numbersign_seq[]={SHIFT,DOWN,0x04,DOWN,0x04,UP,SHIFT,UP,END};
suchar XK_dollar_seq[]={SHIFT,DOWN,0x05,DOWN,0x05,UP,SHIFT,UP,END};
suchar XK_percent_seq[]={SHIFT,DOWN,0x06,DOWN,0x06,UP,SHIFT,UP,END};
suchar XK_ampersand_seq[]={SHIFT,DOWN,0x08,DOWN,0x08,UP,SHIFT,UP,END};
suchar XK_quoteright_seq[]={0x28,DOWN,0x28,UP,END};
suchar XK_parenleft_seq[]={SHIFT,DOWN,0x0a,DOWN,0x0a,UP,SHIFT,UP,END};
suchar XK_parenright_seq[]={SHIFT,DOWN,0x0b,DOWN,0x0b,UP,SHIFT,UP,END};
suchar XK_asterisk_seq[]={0x37,DOWN,0x37,UP,END};
suchar XK_plus_seq[]={0x4e,DOWN,0x4e,UP,END};
suchar XK_comma_seq[]={0x33,DOWN,0x33,UP,END};
suchar XK_minus_seq[]={0x0c,DOWN,0x0c,UP,END};
suchar XK_period_seq[]={0x34,DOWN,0x34,UP,END};
suchar XK_slash_seq[]={0x35,DOWN,0x35,UP,END};
suchar XK_0_seq[]={0x0b,DOWN,0x0b,UP,END};
suchar XK_1_seq[]={0x02,DOWN,0x02,UP,END};
suchar XK_2_seq[]={0x03,DOWN,0x03,UP,END};
suchar XK_3_seq[]={0x04,DOWN,0x04,UP,END};
suchar XK_4_seq[]={0x05,DOWN,0x05,UP,END};
suchar XK_5_seq[]={0x06,DOWN,0x06,UP,END};
suchar XK_6_seq[]={0x07,DOWN,0x07,UP,END};
suchar XK_7_seq[]={0x08,DOWN,0x08,UP,END};
suchar XK_8_seq[]={0x09,DOWN,0x09,UP,END};
suchar XK_9_seq[]={0x0a,DOWN,0x0a,UP,END};
suchar XK_colon_seq[]={SHIFT,DOWN,0x27,DOWN,0x27,UP,SHIFT,UP,END};
suchar XK_semicolon_seq[]={0x27,DOWN,0x27,UP,END};
suchar XK_less_seq[]={SHIFT,DOWN,0x33,DOWN,0x33,UP,SHIFT,UP,END};
suchar XK_equal_seq[]={0x0d,DOWN,0x0d,UP,END};
suchar XK_greater_seq[]={SHIFT,DOWN,0x34,DOWN,0x34,UP,SHIFT,UP,END};
suchar XK_question_seq[]={SHIFT,DOWN,0x35,DOWN,0x35,UP,SHIFT,UP,END};
suchar XK_at_seq[]={SHIFT,DOWN,0x03,DOWN,0x03,UP,SHIFT,UP,END};
suchar XK_A_seq[]={SHIFT,DOWN,0x1e,DOWN,0x1e,UP,SHIFT,UP,END};
suchar XK_B_seq[]={SHIFT,DOWN,0x30,DOWN,0x30,UP,SHIFT,UP,END};
suchar XK_C_seq[]={SHIFT,DOWN,0x2e,DOWN,0x2e,UP,SHIFT,UP,END};
suchar XK_D_seq[]={SHIFT,DOWN,0x20,DOWN,0x20,UP,SHIFT,UP,END};
suchar XK_E_seq[]={SHIFT,DOWN,0x12,DOWN,0x12,UP,SHIFT,UP,END};
suchar XK_F_seq[]={SHIFT,DOWN,0x21,DOWN,0x21,UP,SHIFT,UP,END};
suchar XK_G_seq[]={SHIFT,DOWN,0x22,DOWN,0x22,UP,SHIFT,UP,END};
suchar XK_H_seq[]={SHIFT,DOWN,0x23,DOWN,0x23,UP,SHIFT,UP,END};
suchar XK_I_seq[]={SHIFT,DOWN,0x17,DOWN,0x17,UP,SHIFT,UP,END};
suchar XK_J_seq[]={SHIFT,DOWN,0x24,DOWN,0x24,UP,SHIFT,UP,END};
suchar XK_K_seq[]={SHIFT,DOWN,0x25,DOWN,0x25,UP,SHIFT,UP,END};
suchar XK_L_seq[]={SHIFT,DOWN,0x26,DOWN,0x26,UP,SHIFT,UP,END};
suchar XK_M_seq[]={SHIFT,DOWN,0x32,DOWN,0x32,UP,SHIFT,UP,END};
suchar XK_N_seq[]={SHIFT,DOWN,0x31,DOWN,0x31,UP,SHIFT,UP,END};
suchar XK_O_seq[]={SHIFT,DOWN,0x18,DOWN,0x18,UP,SHIFT,UP,END};
suchar XK_P_seq[]={SHIFT,DOWN,0x19,DOWN,0x19,UP,SHIFT,UP,END};
suchar XK_Q_seq[]={SHIFT,DOWN,0x10,DOWN,0x10,UP,SHIFT,UP,END};
suchar XK_R_seq[]={SHIFT,DOWN,0x13,DOWN,0x13,UP,SHIFT,UP,END};
suchar XK_S_seq[]={SHIFT,DOWN,0x1f,DOWN,0x1f,UP,SHIFT,UP,END};
suchar XK_T_seq[]={SHIFT,DOWN,0x14,DOWN,0x14,UP,SHIFT,UP,END};
suchar XK_U_seq[]={SHIFT,DOWN,0x16,DOWN,0x16,UP,SHIFT,UP,END};
suchar XK_V_seq[]={SHIFT,DOWN,0x2f,DOWN,0x2f,UP,SHIFT,UP,END};
suchar XK_W_seq[]={SHIFT,DOWN,0x11,DOWN,0x11,UP,SHIFT,UP,END};
suchar XK_X_seq[]={SHIFT,DOWN,0x2d,DOWN,0x2d,UP,SHIFT,UP,END};
suchar XK_Y_seq[]={SHIFT,DOWN,0x15,DOWN,0x15,UP,SHIFT,UP,END};
suchar XK_Z_seq[]={SHIFT,DOWN,0x2c,DOWN,0x2c,UP,SHIFT,UP,END};
suchar XK_bracketleft_seq[]={0x1a,DOWN,0x1a,UP,END};
suchar XK_backslash_seq[]={0x2b,DOWN,0x2b,UP,END};
suchar XK_asciicircum_seq[]={SHIFT,DOWN,0x07,DOWN,0x07,UP,SHIFT,UP,END};
suchar XK_underscore_seq[]={SHIFT,DOWN,0x0c,DOWN,0x0c,UP,SHIFT,UP,END};
suchar XK_quoteleft_seq[]={0x29,DOWN,0x29,UP,END};
suchar XK_a_seq[]={0x1e,DOWN,0x1e,UP,END};
suchar XK_b_seq[]={0x30,DOWN,0x30,UP,END};
suchar XK_c_seq[]={0x2e,DOWN,0x2e,UP,END};
suchar XK_d_seq[]={0x20,DOWN,0x20,UP,END};
suchar XK_e_seq[]={0x12,DOWN,0x12,UP,END};
suchar XK_f_seq[]={0x21,DOWN,0x21,UP,END};
suchar XK_g_seq[]={0x22,DOWN,0x22,UP,END};
suchar XK_h_seq[]={0x23,DOWN,0x23,UP,END};
suchar XK_i_seq[]={0x17,DOWN,0x17,UP,END};
suchar XK_j_seq[]={0x24,DOWN,0x24,UP,END};
suchar XK_k_seq[]={0x25,DOWN,0x25,UP,END};
suchar XK_l_seq[]={0x26,DOWN,0x26,UP,END};
suchar XK_m_seq[]={0x32,DOWN,0x32,UP,END};
suchar XK_n_seq[]={0x31,DOWN,0x31,UP,END};
suchar XK_o_seq[]={0x18,DOWN,0x18,UP,END};
suchar XK_p_seq[]={0x19,DOWN,0x19,UP,END};
suchar XK_q_seq[]={0x10,DOWN,0x10,UP,END};
suchar XK_r_seq[]={0x13,DOWN,0x13,UP,END};
suchar XK_s_seq[]={0x1f,DOWN,0x1f,UP,END};
suchar XK_t_seq[]={0x14,DOWN,0x14,UP,END};
suchar XK_u_seq[]={0x16,DOWN,0x16,UP,END};
suchar XK_v_seq[]={0x2f,DOWN,0x2f,UP,END};
suchar XK_w_seq[]={0x11,DOWN,0x11,UP,END};
suchar XK_x_seq[]={0x2d,DOWN,0x2d,UP,END};
suchar XK_y_seq[]={0x15,DOWN,0x15,UP,END};
suchar XK_z_seq[]={0x2c,DOWN,0x2c,UP,END};
suchar XK_braceleft_seq[]={SHIFT,DOWN,0x1a,DOWN,0x1a,UP,SHIFT,UP,END};
suchar XK_bar_seq[]={SHIFT,DOWN,0x2b,DOWN,0x2b,UP,SHIFT,UP,END};
suchar XK_asciitilde_seq[]={SHIFT,DOWN,0x29,DOWN,0x29,UP,SHIFT,UP,END};
suchar XK_Delete_seq[]={0x0e,DOWN,0x0e,UP,END};

suchar XK_Left_seq[]={0x69,DOWN,0x69,UP,END};
suchar XK_Up_seq[]={0x67,DOWN,0x67,UP,END};
suchar XK_Down_seq[]={0x6c,DOWN,0x6c,UP,END};
suchar XK_Right_seq[]={0x6a,DOWN,0x6a,UP,END};
suchar XK_Select_seq[]={0x60,DOWN,0x60,UP,END};

suchar XK_F1_seq[]={0x7a,DOWN,0x7a,UP,END};
suchar XK_F2_seq[]={0x7b,DOWN,0x7b,UP,END};
suchar XK_F3_seq[]={0x7c,DOWN,0x7c,UP,END};
suchar XK_F4_seq[]={0x7d,DOWN,0x7d,UP,END};
suchar XK_F5_seq[]={0x78,DOWN,0x78,UP,END};

#else   /* #ifdef ZAURUS */

#define CONTROL_DOWN SHIFT,DOWN,30,DOWN
#define CONTROL_UP   30,UP,SHIFT,UP
#define SHIFT 0x1b

suchar XK_BackSpace_seq[]={0x1f,DOWN,0x1f,UP,END};
suchar XK_Tab_seq[]={0x41,DOWN,0x41,UP,END};
suchar XK_Return_seq[]={0x1c,DOWN,0x1c,UP,END};
suchar XK_Escape_seq[]={0x22,DOWN,0x22,UP,END};
suchar XK_space_seq[]={0x5c,DOWN,0x5c,UP,END};
suchar XK_exclam_seq[]={0x5e,DOWN,0x5e,UP,END};
suchar XK_quotedbl_seq[]={0x48,DOWN,0x48,UP,END};
suchar XK_numbersign_seq[]={0x4a,DOWN,0x4a,UP,END};
suchar XK_dollar_seq[]={0x4b,DOWN,0x4b,UP,END};
suchar XK_percent_seq[]={0x4c,DOWN,0x4c,UP,END};
suchar XK_ampersand_seq[]={0x4e,DOWN,0x4e,UP,END};
suchar XK_quoteright_seq[]={0x46,DOWN,0x46,UP,END};
suchar XK_parenleft_seq[]={0x50,DOWN,0x50,UP,END};
suchar XK_parenright_seq[]={0x54,DOWN,0x54,UP,END};
suchar XK_asterisk_seq[]={0x4f,DOWN,0x4f,UP,END};
suchar XK_plus_seq[]={0x3b,DOWN,0x3b,UP,END};
suchar XK_comma_seq[]={0x3f,DOWN,0x3f,UP,END};
suchar XK_minus_seq[]={0x3a,DOWN,0x3a,UP,END};
suchar XK_period_seq[]={0x40,DOWN,0x40,UP,END};
suchar XK_slash_seq[]={0x45,DOWN,0x45,UP,END};
suchar XK_0_seq[]={0x32,DOWN,0x32,UP,END};
suchar XK_1_seq[]={0x29,DOWN,0x29,UP,END};
suchar XK_2_seq[]={0x2a,DOWN,0x2a,UP,END};
suchar XK_3_seq[]={0x2b,DOWN,0x2b,UP,END};
suchar XK_4_seq[]={0x2c,DOWN,0x2c,UP,END};
suchar XK_5_seq[]={0x2d,DOWN,0x2d,UP,END};
suchar XK_6_seq[]={0x2e,DOWN,0x2e,UP,END};
suchar XK_7_seq[]={0x2f,DOWN,0x2f,UP,END};
suchar XK_8_seq[]={0x30,DOWN,0x30,UP,END};
suchar XK_9_seq[]={0x31,DOWN,0x31,UP,END};
suchar XK_colon_seq[]={0x49,DOWN,0x49,UP,END};
suchar XK_semicolon_seq[]={0x47,DOWN,0x47,UP,END};
suchar XK_less_seq[]={0x56,DOWN,0x56,UP,END};
suchar XK_equal_seq[]={0x53,DOWN,0x53,UP,END};
suchar XK_greater_seq[]={0x57,DOWN,0x57,UP,END};
suchar XK_question_seq[]={0x3e,DOWN,0x3e,UP,END};
suchar XK_at_seq[]={0x3d,DOWN,0x3d,UP,END};
suchar XK_A_seq[]={SHIFT,DOWN,0x01,DOWN,0x01,UP,SHIFT,UP,END};
suchar XK_B_seq[]={SHIFT,DOWN,0x02,DOWN,0x02,UP,SHIFT,UP,END};
suchar XK_C_seq[]={SHIFT,DOWN,0x03,DOWN,0x03,UP,SHIFT,UP,END};
suchar XK_D_seq[]={SHIFT,DOWN,0x04,DOWN,0x04,UP,SHIFT,UP,END};
suchar XK_E_seq[]={SHIFT,DOWN,0x05,DOWN,0x05,UP,SHIFT,UP,END};
suchar XK_F_seq[]={SHIFT,DOWN,0x06,DOWN,0x06,UP,SHIFT,UP,END};
suchar XK_G_seq[]={SHIFT,DOWN,0x07,DOWN,0x07,UP,SHIFT,UP,END};
suchar XK_H_seq[]={SHIFT,DOWN,0x08,DOWN,0x08,UP,SHIFT,UP,END};
suchar XK_I_seq[]={SHIFT,DOWN,0x09,DOWN,0x09,UP,SHIFT,UP,END};
suchar XK_J_seq[]={SHIFT,DOWN,0x0a,DOWN,0x0a,UP,SHIFT,UP,END};
suchar XK_K_seq[]={SHIFT,DOWN,0x0b,DOWN,0x0b,UP,SHIFT,UP,END};
suchar XK_L_seq[]={SHIFT,DOWN,0x0c,DOWN,0x0c,UP,SHIFT,UP,END};
suchar XK_M_seq[]={SHIFT,DOWN,0x0d,DOWN,0x0d,UP,SHIFT,UP,END};
suchar XK_N_seq[]={SHIFT,DOWN,0x0e,DOWN,0x0e,UP,SHIFT,UP,END};
suchar XK_O_seq[]={SHIFT,DOWN,0x0f,DOWN,0x0f,UP,SHIFT,UP,END};
suchar XK_P_seq[]={SHIFT,DOWN,0x10,DOWN,0x10,UP,SHIFT,UP,END};
suchar XK_Q_seq[]={SHIFT,DOWN,0x11,DOWN,0x11,UP,SHIFT,UP,END};
suchar XK_R_seq[]={SHIFT,DOWN,0x12,DOWN,0x12,UP,SHIFT,UP,END};
suchar XK_S_seq[]={SHIFT,DOWN,0x13,DOWN,0x13,UP,SHIFT,UP,END};
suchar XK_T_seq[]={SHIFT,DOWN,0x14,DOWN,0x14,UP,SHIFT,UP,END};
suchar XK_U_seq[]={SHIFT,DOWN,0x15,DOWN,0x15,UP,SHIFT,UP,END};
suchar XK_V_seq[]={SHIFT,DOWN,0x16,DOWN,0x16,UP,SHIFT,UP,END};
suchar XK_W_seq[]={SHIFT,DOWN,0x17,DOWN,0x17,UP,SHIFT,UP,END};
suchar XK_X_seq[]={SHIFT,DOWN,0x18,DOWN,0x18,UP,SHIFT,UP,END};
suchar XK_Y_seq[]={SHIFT,DOWN,0x19,DOWN,0x19,UP,SHIFT,UP,END};
suchar XK_Z_seq[]={SHIFT,DOWN,0x1a,DOWN,0x1a,UP,SHIFT,UP,END};
suchar XK_underscore_seq[]={0x4d,DOWN,0x4d,UP,END};
suchar XK_a_seq[]={0x01,DOWN,0x01,UP,END};
suchar XK_a_seq_control[]={CONTROL_DOWN,0x01,DOWN,0x01,UP,CONTROL_UP,END};
suchar XK_b_seq[]={0x02,DOWN,0x02,UP,END};
suchar XK_b_seq_control[]={CONTROL_DOWN,0x02,DOWN,0x02,UP,CONTROL_UP,END};
suchar XK_c_seq[]={0x03,DOWN,0x03,UP,END};
suchar XK_c_seq_control[]={CONTROL_DOWN,0x03,DOWN,0x03,UP,CONTROL_UP,END};
suchar XK_d_seq[]={0x04,DOWN,0x04,UP,END};
suchar XK_d_seq_control[]={CONTROL_DOWN,0x04,DOWN,0x04,UP,CONTROL_UP,END};
suchar XK_e_seq[]={0x05,DOWN,0x05,UP,END};
suchar XK_e_seq_control[]={CONTROL_DOWN,0x05,DOWN,0x05,UP,CONTROL_UP,END};
suchar XK_f_seq[]={0x06,DOWN,0x06,UP,END};
suchar XK_f_seq_control[]={CONTROL_DOWN,0x06,DOWN,0x06,UP,CONTROL_UP,END};
suchar XK_g_seq[]={0x07,DOWN,0x07,UP,END};
suchar XK_g_seq_control[]={CONTROL_DOWN,0x07,DOWN,0x07,UP,CONTROL_UP,END};
suchar XK_h_seq[]={0x08,DOWN,0x08,UP,END};
suchar XK_h_seq_control[]={CONTROL_DOWN,0x08,DOWN,0x08,UP,CONTROL_UP,END};
suchar XK_i_seq[]={0x09,DOWN,0x09,UP,END};
suchar XK_i_seq_control[]={CONTROL_DOWN,0x09,DOWN,0x09,UP,CONTROL_UP,END};
suchar XK_j_seq[]={0x0a,DOWN,0x0a,UP,END};
suchar XK_j_seq_control[]={CONTROL_DOWN,0x0a,DOWN,0x0a,UP,CONTROL_UP,END};
suchar XK_k_seq[]={0x0b,DOWN,0x0b,UP,END};
suchar XK_k_seq_control[]={CONTROL_DOWN,0x0b,DOWN,0x0b,UP,CONTROL_UP,END};
suchar XK_l_seq[]={0x0c,DOWN,0x0c,UP,END};
suchar XK_l_seq_control[]={CONTROL_DOWN,0x0c,DOWN,0x0c,UP,CONTROL_UP,END};
suchar XK_m_seq[]={0x0d,DOWN,0x0d,UP,END};
suchar XK_m_seq_control[]={CONTROL_DOWN,0x0d,DOWN,0x0d,UP,CONTROL_UP,END};
suchar XK_n_seq[]={0x0e,DOWN,0x0e,UP,END};
suchar XK_n_seq_control[]={CONTROL_DOWN,0x0e,DOWN,0x0e,UP,CONTROL_UP,END};
suchar XK_o_seq[]={0x0f,DOWN,0x0f,UP,END};
suchar XK_o_seq_control[]={CONTROL_DOWN,0x0f,DOWN,0x0f,UP,CONTROL_UP,END};
suchar XK_p_seq[]={0x10,DOWN,0x10,UP,END};
suchar XK_p_seq_control[]={CONTROL_DOWN,0x10,DOWN,0x10,UP,CONTROL_UP,END};
suchar XK_q_seq[]={0x11,DOWN,0x11,UP,END};
suchar XK_q_seq_control[]={CONTROL_DOWN,0x11,DOWN,0x11,UP,CONTROL_UP,END};
suchar XK_r_seq[]={0x12,DOWN,0x12,UP,END};
suchar XK_r_seq_control[]={CONTROL_DOWN,0x12,DOWN,0x12,UP,CONTROL_UP,END};
suchar XK_s_seq[]={0x13,DOWN,0x13,UP,END};
suchar XK_s_seq_control[]={CONTROL_DOWN,0x13,DOWN,0x13,UP,CONTROL_UP,END};
suchar XK_t_seq[]={0x14,DOWN,0x14,UP,END};
suchar XK_t_seq_control[]={CONTROL_DOWN,0x14,DOWN,0x14,UP,CONTROL_UP,END};
suchar XK_u_seq[]={0x15,DOWN,0x15,UP,END};
suchar XK_u_seq_control[]={CONTROL_DOWN,0x15,DOWN,0x15,UP,CONTROL_UP,END};
suchar XK_v_seq[]={0x16,DOWN,0x16,UP,END};
suchar XK_v_seq_control[]={CONTROL_DOWN,0x16,DOWN,0x16,UP,CONTROL_UP,END};
suchar XK_w_seq[]={0x17,DOWN,0x17,UP,END};
suchar XK_w_seq_control[]={CONTROL_DOWN,0x17,DOWN,0x17,UP,CONTROL_UP,END};
suchar XK_x_seq[]={0x18,DOWN,0x18,UP,END};
suchar XK_x_seq_control[]={CONTROL_DOWN,0x18,DOWN,0x18,UP,CONTROL_UP,END};
suchar XK_y_seq[]={0x19,DOWN,0x19,UP,END};
suchar XK_y_seq_control[]={CONTROL_DOWN,0x19,DOWN,0x19,UP,CONTROL_UP,END};
suchar XK_z_seq[]={0x1a,DOWN,0x1a,UP,END};
suchar XK_z_seq_control[]={CONTROL_DOWN,0x1a,DOWN,0x1a,UP,CONTROL_UP,END};
suchar XK_bar_seq[]={SHIFT,DOWN,0x5c,DOWN,0x5c,UP,SHIFT,UP,END};
suchar XK_asciitilde_seq[]={0x55,DOWN,0x55,UP,END};
suchar XK_Delete_seq[]={0x51,DOWN,0x51,UP,END};

suchar XK_Left_seq[]={0x23,DOWN,0x23,UP,END};
suchar XK_Up_seq[]={0x24,DOWN,0x24,UP,END};
suchar XK_Down_seq[]={0x25,DOWN,0x25,UP,END};
suchar XK_Right_seq[]={0x26,DOWN,0x26,UP,END};
suchar XK_Select_seq[]={0x5b,DOWN,0x5b,UP,END};

suchar XK_F1_seq[]={0x58,DOWN,0x58,UP,END};
suchar XK_F2_seq[]={0x59,DOWN,0x59,UP,END};
suchar XK_F3_seq[]={0x28,DOWN,0x28,UP,END};
suchar XK_F4_seq[]={0x1d,DOWN,0x1d,UP,END};
suchar XK_F5_seq[]={0x5a,DOWN,0x5a,UP,END};

suchar XK_backslash_seq[] = {SHIFT,DOWN,65,DOWN,65,UP,SHIFT,UP,END};
suchar XK_braceleft_seq[] = {SHIFT,DOWN,86,DOWN,86,UP,SHIFT,UP,END};
suchar XK_asciicircum_seq[] = {SHIFT,DOWN,85,DOWN,85,UP,SHIFT,UP,END};
suchar XK_quoteleft_seq[] = {SHIFT,DOWN,CONTROL_DOWN,32,DOWN,32,UP,CONTROL_UP,SHIFT,UP,END};
suchar XK_braceright_seq[] = {SHIFT,DOWN,87,DOWN,87,UP,SHIFT,UP,END};
suchar XK_bracketleft_seq[] = {SHIFT,DOWN,30,DOWN,81,DOWN,81,UP,30,UP,SHIFT,UP,END};
suchar XK_bracketright_seq[] = {SHIFT,DOWN,30,DOWN,84,DOWN,84,UP,30,UP,SHIFT,UP,END};

#endif

#ifdef IPAQ
#    define POSSIBLE_CONTROL(x) x
#else
#    define POSSIBLE_CONTROL(x) (control_down?x##_control:x)
#endif



/* Turn a received keysym into a Zaurus keyboard scancode sequence. Each
   sequence is terminated by 0xff. Return NULL if no scancode could be found */
unsigned char *keysym2scancodes(Bool down, KeySym key)
{
#ifndef IPAQ
  static int control_down = 0;
#endif
  if(down) {
    switch(key)
    {
        case XK_BackSpace:          return(XK_BackSpace_seq);
        case XK_Tab:                return(XK_Tab_seq);
        case XK_KP_Tab:             return(XK_Tab_seq);
        case XK_Return:             return(XK_Return_seq);
        case XK_KP_Enter:           return(XK_Return_seq);
        case XK_Escape:             return(XK_Escape_seq);
        case XK_space:              return(XK_space_seq);
        case XK_KP_Space:           return(XK_space_seq);
        case XK_exclam:             return(XK_exclam_seq);
        case XK_quotedbl:           return(XK_quotedbl_seq);
        case XK_numbersign:         return(XK_numbersign_seq);
        case XK_dollar:             return(XK_dollar_seq);
        case XK_percent:            return(XK_percent_seq);
        case XK_ampersand:          return(XK_ampersand_seq);
        case XK_quoteright:         return(XK_quoteright_seq);
        case XK_parenleft:          return(XK_parenleft_seq);
        case XK_parenright:         return(XK_parenright_seq);
        case XK_asterisk:           return(XK_asterisk_seq);
        case XK_KP_Multiply:        return(XK_asterisk_seq);
        case XK_plus:               return(XK_plus_seq);
        case XK_KP_Add:             return(XK_plus_seq);
        case XK_comma:              return(XK_comma_seq);
        case XK_minus:              return(XK_minus_seq);
        case XK_KP_Subtract:        return(XK_minus_seq);
        case XK_period:             return(XK_period_seq);
        case XK_KP_Decimal:         return(XK_period_seq);
        case XK_slash:              return(XK_slash_seq);
        case XK_KP_Divide:          return(XK_slash_seq);
        case XK_0:                  return(XK_0_seq);
        case XK_KP_0:               return(XK_0_seq);
        case XK_1:                  return(XK_1_seq);
        case XK_KP_1:               return(XK_1_seq);
        case XK_2:                  return(XK_2_seq);
        case XK_KP_2:               return(XK_2_seq);
        case XK_3:                  return(XK_3_seq);
        case XK_KP_3:               return(XK_3_seq);
        case XK_4:                  return(XK_4_seq);
        case XK_KP_4:               return(XK_4_seq);
        case XK_5:                  return(XK_5_seq);
        case XK_KP_5:               return(XK_5_seq);
        case XK_6:                  return(XK_6_seq);
        case XK_KP_6:               return(XK_6_seq);
        case XK_7:                  return(XK_7_seq);
        case XK_KP_7:               return(XK_7_seq);
        case XK_8:                  return(XK_8_seq);
        case XK_KP_8:               return(XK_8_seq);
        case XK_9:                  return(XK_9_seq);
        case XK_KP_9:               return(XK_9_seq);
        case XK_colon:              return(XK_colon_seq);
        case XK_semicolon:          return(XK_semicolon_seq);
        case XK_less:               return(XK_less_seq);
        case XK_equal:              return(XK_equal_seq);
        case XK_greater:            return(XK_greater_seq);
        case XK_question:           return(XK_question_seq);
        case XK_at:                 return(XK_at_seq);
        case XK_A:                  return(XK_A_seq);
        case XK_B:                  return(XK_B_seq);
        case XK_C:                  return(XK_C_seq);
        case XK_D:                  return(XK_D_seq);
        case XK_E:                  return(XK_E_seq);
        case XK_F:                  return(XK_F_seq);
        case XK_G:                  return(XK_G_seq);
        case XK_H:                  return(XK_H_seq);
        case XK_I:                  return(XK_I_seq);
        case XK_J:                  return(XK_J_seq);
        case XK_K:                  return(XK_K_seq);
        case XK_L:                  return(XK_L_seq);
        case XK_M:                  return(XK_M_seq);
        case XK_N:                  return(XK_N_seq);
        case XK_O:                  return(XK_O_seq);
        case XK_P:                  return(XK_P_seq);
        case XK_Q:                  return(XK_Q_seq);
        case XK_R:                  return(XK_R_seq);
        case XK_S:                  return(XK_S_seq);
        case XK_T:                  return(XK_T_seq);
        case XK_U:                  return(XK_U_seq);
        case XK_V:                  return(XK_V_seq);
        case XK_W:                  return(XK_W_seq);
        case XK_X:                  return(XK_X_seq);
        case XK_Y:                  return(XK_Y_seq);
        case XK_Z:                  return(XK_Z_seq);
        case XK_bracketleft:        return(XK_bracketleft_seq);
        case XK_backslash:          return(XK_backslash_seq);
        case XK_asciicircum:        return(XK_asciicircum_seq);
        case XK_underscore:         return(XK_underscore_seq);
        case XK_quoteleft:          return(XK_quoteleft_seq);
        case XK_a:                  return(POSSIBLE_CONTROL(XK_a_seq));
        case XK_b:                  return(POSSIBLE_CONTROL(XK_b_seq));
        case XK_c:                  return(POSSIBLE_CONTROL(XK_c_seq));
        case XK_d:                  return(POSSIBLE_CONTROL(XK_d_seq));
        case XK_e:                  return(POSSIBLE_CONTROL(XK_e_seq));
        case XK_f:                  return(POSSIBLE_CONTROL(XK_f_seq));
        case XK_g:                  return(POSSIBLE_CONTROL(XK_g_seq));
        case XK_h:                  return(POSSIBLE_CONTROL(XK_h_seq));
        case XK_i:                  return(POSSIBLE_CONTROL(XK_i_seq));
        case XK_j:                  return(POSSIBLE_CONTROL(XK_j_seq));
        case XK_k:                  return(POSSIBLE_CONTROL(XK_k_seq));
        case XK_l:                  return(POSSIBLE_CONTROL(XK_l_seq));
        case XK_m:                  return(POSSIBLE_CONTROL(XK_m_seq));
        case XK_n:                  return(POSSIBLE_CONTROL(XK_n_seq));
        case XK_o:                  return(POSSIBLE_CONTROL(XK_o_seq));
        case XK_p:                  return(POSSIBLE_CONTROL(XK_p_seq));
        case XK_q:                  return(POSSIBLE_CONTROL(XK_q_seq));
        case XK_r:                  return(POSSIBLE_CONTROL(XK_r_seq));
        case XK_s:                  return(POSSIBLE_CONTROL(XK_s_seq));
        case XK_t:                  return(POSSIBLE_CONTROL(XK_t_seq));
        case XK_u:                  return(POSSIBLE_CONTROL(XK_u_seq));
        case XK_v:                  return(POSSIBLE_CONTROL(XK_v_seq));
        case XK_w:                  return(POSSIBLE_CONTROL(XK_w_seq));
        case XK_x:                  return(POSSIBLE_CONTROL(XK_x_seq));
        case XK_y:                  return(POSSIBLE_CONTROL(XK_y_seq));
        case XK_z:                  return(POSSIBLE_CONTROL(XK_z_seq));
        case XK_braceleft:          return(XK_braceleft_seq);
        case XK_bar:                return(XK_bar_seq);
        case XK_asciitilde:         return(XK_asciitilde_seq);
        case XK_Delete:             return(XK_Delete_seq);

        case XK_Left:               return(XK_Left_seq);
        case XK_KP_Left:            return(XK_Left_seq);
        case XK_Up:                 return(XK_Up_seq);
        case XK_KP_Up:              return(XK_Up_seq);
        case XK_Down:               return(XK_Down_seq);
        case XK_KP_Down:            return(XK_Down_seq);
        case XK_Right:              return(XK_Right_seq);
        case XK_KP_Right:           return(XK_Right_seq);
        case XK_End:                return(XK_Select_seq);
        case XK_KP_End:             return(XK_Select_seq);
        case XK_Home:               return(XK_F3_seq);
        case XK_KP_Home:            return(XK_F3_seq);
        case XK_Page_Down:          return(XK_F4_seq);
        case XK_KP_Page_Down:       return(XK_F4_seq);

        case XK_F1:                 return(XK_F1_seq);
        case XK_F2:                 return(XK_F2_seq);
        case XK_F3:                 return(XK_F3_seq);
        case XK_F4:                 return(XK_F4_seq);
        case XK_F5:                 return(XK_F5_seq);

#ifndef IPAQ
        case XK_braceright:         return(XK_braceright_seq);
        case XK_bracketright:       return(XK_bracketright_seq);
        case XK_Control_L:
        case XK_Control_R:          control_down = 1; break;
#endif

        default:                    return(NULL);
    }
  } else {
    switch(key) {
#ifndef IPAQ
        case XK_Control_L:
        case XK_Control_R:              control_down = 0; break;
#endif
    }
  }
  return NULL;
}
