#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <sys/mman.h>
#include "subclass.h"
#include <qlabel.h>
#include <qprogressbar.h>
#include <qpixmap.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <qpe/process.h>
#include <qpe/global.h>

#define SCRIPT_LOCATION "/usr/local/bin"


mainDialog::mainDialog(QWidget *parent, const char *name, WFlags fl)
    : mainDialogSuper(parent, name, fl)
{
    QPixmap qi("/home/root/Applications/fbvncserver/sdglogo.png", "PNG");
    QSizePolicy qsp(QSizePolicy::Fixed, QSizePolicy::Fixed);
    SDG_Pixmap->setSizePolicy(qsp);
    SDG_Pixmap->setPixmap(qi);
}
mainDialog::~mainDialog() /* {{{ */
{
} /* }}} */

void mainDialog::accept() {
    char *run_script = 0;
    QRadioButton *selected = (QRadioButton *)radioButtonGroup->selected();
    if(selected == radioMinimal) {
        run_script = "vncserver_minimal_up";
    }
    if(selected == radioMinimalCW) {
        run_script = "vncserver_rotatecw_up";
    }
    if(selected == radioDouble) {
        run_script = "vncserver_double_up";
    }
    if(selected == radioDoubleCW) {
        run_script = "vncserver_rotatecw_double_up";
    }
    if(selected == radioFancy) {
        run_script = "vncserver_fancy_up";
    }
    if(selected == radioFancySplit) {
        run_script = "vncserver_split_up";
    }
    if(selected == radioHalt) {
        run_script = "vncserver_down";
    }
    if(run_script && makeDefaultCheckbox->isEnabled() && makeDefaultCheckbox->isChecked()) {
        char *dest;
        dest = (char *)malloc(1024);
        if(dest) {
            snprintf(dest, 1024, "cd %s; ln -sf %s vncserver_default_up",
                SCRIPT_LOCATION, run_script);
            system(dest);
            free(dest);
        }
    }
    if(passwordCheckBox->isChecked()) {
        // Only warn the user if they have not selected a server to launch.
        // This is true when run_script is null.
        if(run_script || (0 == QMessageBox::warning(this, "Change Password",
                "Changing the password requires\n"
                "a restart of the VNC Server.\n"
                "Are you sure?",
                "Yes", "No", 0, 1))) {
            if(passwordEdit->text().ascii()[0] == 0) {
                system("rm $HOME/.fbvncpasswd");
            } else {
                char *dest;
                dest = (char *)malloc(1024);
                if(dest) {
                    snprintf(dest, 1024, "cd %s; ./storepasswd %s $HOME/.fbvncpasswd",
                        SCRIPT_LOCATION, passwordEdit->text().ascii());
                    system(dest);
                    free(dest);
                    passwordEdit->clear();
                }
            }
            Global::execute("vncserver_last_up");
        } else {
            if(!run_script) {
                return;
            }
        }
    }
    if(run_script) {
        char *dest;
        dest = (char *)malloc(1024);
        if(dest) {
            snprintf(dest, 1024, "cd %s; ln -sf %s vncserver_last_up",
                SCRIPT_LOCATION, run_script);
            system(dest);
            free(dest);
        }
        Global::execute(run_script);
    }
    QDialog::accept();
    QDialog::close(TRUE);
}

void mainDialog::reject() {
    QDialog::reject();
    QWidget::close(TRUE);
}

// vim600: set foldmethod=marker :
